/*
	what we need for the network
*/

#define LEN_SERVERNAME 64
#define LEN_PORT 6
#define LEN_GAMENAME 32
#define LEN_VERSION 10
#define BUF_SIZE 1024
#define DEFAULT_UDPPORT "11100"
#define DEFAULT_GAMETIMEOUT 1800
#define DEFAULT_BROWSETIMEOUT 600
#define IRC_LINESIZE 512
#define TCP_INSIZE 512
#define CFG_FILENAME ".bomberclonemserv.cfg"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <time.h>
#include <string>
#include <fstream>
#include <iostream>
using namespace std;

#ifdef _WIN32
#include <winsock.h>
#else
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#endif

#include "cpplist.h"
#include "tcpip.h"

extern char botnick[64];
extern int botenable;
extern char botowner[128];
extern char botpass[64];
extern char botemail[128];
extern char botchan[128];
extern char bothost[128];
extern char botport[10];

struct browse_entry {
    char host[LEN_SERVERNAME];
    char port[LEN_PORT];
	struct _sockaddr addr;
    signed char ai_family;
    time_t timestamp;
};

class BrowseList:public List {
  public:
    BrowseList ();
    ~BrowseList ();
    void Add (struct browse_entry *ge); // Add
    void Add (struct _sockaddr *Addr, char *data); // Add
    void Del (char *host, char *port); // Delete Entry
    void Del (struct _sockaddr *Addr); // Delete Entry
    void Del (int nr);          // Delete Entry
    void CleanUp ();            // Delete Old Entrys
    void PrintList ();          // Print The List
    struct browse_entry *Get (int nr); // get Entry
    int Search (char *host, char *port); // search for this server
    void Update (int nr, struct browse_entry *ge); // Update
    void GetSockAddr (struct _sockaddr Addr, int nr); // Get Socket
};


struct game_entry {
    char host[LEN_SERVERNAME];
    char port[LEN_PORT];
    char name[LEN_GAMENAME];
	struct _sockaddr addr;
    struct _version {
        unsigned char major;
        unsigned char minor;
        unsigned char sub;
    } version;
    signed char curplayers;
    signed char maxplayers;
    signed char ai_family;
    unsigned char state;
    unsigned char multitype;
    unsigned char gametype;
    time_t timestamp;
};


class GameList:public List {
  public:
    GameList ();
    ~GameList ();

	/* this is only for the statisic */
	int stat_countedgamesv6;
	int stat_countedgamesv4;
	char stat_maxplayerhost[128];
	char stat_maxplayerport[10];
	char stat_maxplayername[64];
	int stat_maxplayers;
	
    void Add (struct game_entry *ge); // Add
    void Add (struct _sockaddr *Addr, char *data); // Add
    void Del (char *host, char *port); // Delete Entry
    void Del (struct _sockaddr *Addr); // Delete Entry
    void Del (int nr);          // Delete Entry
    void CleanUp ();            // Delete Old Entrys
    void PrintList ();          // Print The List
	void CreatePacket (int nr, char *data, int len); // Create Data Packet for Send
    struct game_entry *Get (int nr); // get Entry
    int Search (char *host, char *port); // search for this server
    void Update (int nr, struct game_entry *ge); // Update
};


class UDPNetwork {
  public:
    UDPNetwork (char *port);
     ~UDPNetwork ();
    void senddata (char *host, char *port, char *data, int len);
    void senddata (struct _sockaddr *Addr, char *data, int len);
    int getdata (char *buf, int buf_size, struct _sockaddr *Addr);
  private:
    int sock;
};


class TCPClient {
  public:
    TCPClient ();
     ~TCPClient ();
	void connect (char *host, char *port);
    void senddata (char *data, int len);
    int getdata (char *buf, int buf_size);
	void close ();
  private:
    int sock;
};


class IRCClient {
	public:
		char sendtext[IRC_LINESIZE];
		char sendnick[64];
		IRCClient (char *host, char *port, char *nickname, char *pass, char *channel);
		~IRCClient ();
		void sendline (char *to, char *text);
		int loop ();
		int getmessage (char *in, char *channick);
		void close ();
	private:
		TCPClient tcp;
		char chan[64];
		char nick[64];
};

