/*
 * Browselist Class 
 */

#include "bcmserv.h"


BrowseList::BrowseList ()
{
};


BrowseList::~BrowseList ()
{
};




void
BrowseList::Update (int nr, struct browse_entry *ge)
{
    struct browse_entry *georg = 0;

    georg = (struct browse_entry *) List::Get (nr);
    if (georg == 0) {
        delete ge;
        return;
    }

    *georg = *ge;
    delete ge;
};


void
BrowseList::Add (struct _sockaddr *Addr, char *data)
{
    int i;
    struct browse_entry *ge = new struct browse_entry;

    for (i = 0; i < LEN_SERVERNAME; i++) {
        ge->host[i] = 0;
        if (i < LEN_PORT)
            ge->port[i] = 0;
    };

    ge->timestamp = time (NULL);
    dns_filladdr (ge->host, LEN_SERVERNAME, ge->port, LEN_PORT, ((struct sockaddr*)Addr)->sa_family, Addr);
    if (ge->host[0] == 0 || ge->port[0] == 0) {
        printf ("something wrong\n");
        delete ge;
        return;
    }

    printf ("Browselist Add oky\n");
    Add (ge);
};


void
BrowseList::Add (struct browse_entry *ge)
{
    int nr;

    nr = Search (ge->host, ge->port);

    if (nr != -1)
        Update (nr, ge);
    else
        List::Add (ge);
};




void
BrowseList::Del (int nr)
{
    struct browse_entry *ge = 0;

    ge = Get (nr);
    delete ge;
    List::Del (nr);
};


void
BrowseList::PrintList ()
{
    int i;

    cout << "****** BrowseList\n";

    for (i = 0; i < count; i++) {
        struct browse_entry *ge = Get (i);
        cout << "Host : " << ge->host << " Port : " << ge->port << "\n";
    }

};

void
BrowseList::Del (char *host, char *port)
{
    int nr;

    nr = Search (host, port);
    if (nr != -1)
        Del (nr);
};

void
BrowseList::Del (struct _sockaddr *Addr)
{
    char host[LEN_SERVERNAME], port[LEN_PORT];

    host[0] = 0;
    port[0] = 0;

    dns_filladdr (host, LEN_SERVERNAME, port, LEN_PORT, PF_UNSPEC, Addr);

    Del (host, port);
};


struct browse_entry *
BrowseList::Get (int nr)
{
    return (struct browse_entry *) List::Get (nr);
};


int
BrowseList::Search (char *host, char *port)
{
    struct browse_entry *ge;
    int i,
        y;

    for (i = 0, y = -1; (i < count) && (y == -1); i++) {
        ge = (struct browse_entry *) List::Get (i);
        if (strcmp (ge->host, host) == 0 && strcmp (ge->port, port) == 0)
            y = i;
    }

    return y;
};


void
BrowseList::CleanUp ()
{
    int i,
        y;
    struct browse_entry *ge;
    time_t timestamp;

    timestamp = time (NULL);

    for (i = 0, y = -1; (i < count) && (y == -1); i++) {
        ge = (struct browse_entry *) List::Get (i);
        if (timestamp - ge->timestamp >= DEFAULT_BROWSETIMEOUT)
            y = i;
    }

    if (y != -1)
        Del (y);
};

void
BrowseList::GetSockAddr (struct _sockaddr Addr,int nr)
{
    struct browse_entry *ge;
	
	ge=(struct browse_entry *) Get(nr);
	Addr=ge->addr;
};
