/*
	Double Linked lists for C++
	C++ File
	Fileversion 1.0
*/

#include "cpplist.h"

/* Init the Single Element */
List::Entry::Entry (void *dat, Entry * pre, Entry * nxt)
{
    data = dat;
	prev = pre;
    next = nxt;
};

/* Destructor for the Element */
List::Entry::~Entry ()
{
};

/* do the init stuff */
List::List ()
{
    FirstEntry = 0;
	LastEntry = 0;
	count = 0;
};

/* Add a new Element to the List */
int
List::Add (void *dat)
{
	if (FirstEntry == 0) {
		LastEntry = new Entry (dat, 0, 0);
		FirstEntry = LastEntry;
	}
	else {
		LastEntry = new Entry (dat, LastEntry, 0);
		LastEntry->prev->next = LastEntry;
	}
	count++;

	return (count-1);
};


/* Get a Element */
void *
List::Get (int nr)
{
	Entry *ent;
	
	if (nr > count)
		return 0;
	
	ent = FirstEntry;
	while (nr != 0 && ent != 0) {
		nr--;
		ent = ent->next;
	}

	if (ent == 0)
		return 0;
	else
		return ent->data;
};

/* Delete a single Element */
void
List::Del (int nr)
{
	Entry *ent;

	if (nr > count || FirstEntry == 0 || count == 0)
		return;

	ent = FirstEntry;
	while (nr != 0 && ent != 0) {
		nr--;
		ent = ent->next;
	}

	if (ent == 0)
		return;
	
	if (ent->next != 0)
		ent->next->prev = ent->prev;
	if (ent->prev != 0)	
		ent->prev->next = ent->next;
	if (FirstEntry == ent)
		FirstEntry = ent->next;
	if (LastEntry == ent)
		LastEntry = ent->prev;

    delete ent;

	count--;
	
    return;
};

/* Delete the whole list and if we have to Delete all the Elements from the List*/
List::~List ()
{
	if (count != 0)
	
	while (FirstEntry != 0)
		Del (0);
};
