/* irc.cc : irc network */

#include "bcmserv.h"

IRCClient::IRCClient (char *host, char *port, char *nickname, char *pass, char *channel) {
	char out[255];
	int step = 0;
	int inlen;
	char inbuffer[TCP_INSIZE];
	char *text;
	
	cout << "Connect to IRC Server\n";
	
	tcp.connect (host, port);
	sprintf (nick, "%s", nickname);
	sprintf (out,"NICK %s\n",nick);
	tcp.senddata (out, strlen (out));
	
	while (step<1) {
		
		inlen = tcp.getdata (inbuffer, TCP_INSIZE);
		inbuffer[inlen] = 0;
		if (inlen <0) return;

		/* Suchen ob schon eine Anmeldung war ? */
		if (strstr(inbuffer,"PING") == inbuffer) {
			text = strchr (inbuffer,':');
			if (text == NULL) 
				fprintf (stderr,"Fehler PING ohne :\n");
			else {
				text++;
				sprintf (out, "PONG %s\n",text);
				tcp.senddata (out,strlen(out));
			  }
		}
		
		if ((strstr(inbuffer,"AUTH") != NULL) && (strstr(inbuffer,"NOTICE") !=NULL) && (step == 0)) {
			step = 1;
			sprintf (out, "USER %s %s %s %s\n",nickname,nickname,nickname,nickname);
			tcp.senddata (out,strlen(out));
		}
	}
	
	sprintf (chan,"%s",channel);

	sprintf (out," 001 %s", nick);
	while (step < 2) {
		inlen = tcp.getdata (inbuffer, TCP_INSIZE);
		inbuffer[inlen] = 0;
		if (inlen <0) return;

		/* wait untill we have joined the channel */
		if (strstr (inbuffer, out))
			step = 2;
	}

	sprintf (out, "PRIVMSG nickserv :identify %s\n", pass);
	tcp.senddata (out, strlen (out));

	sprintf (out,"JOIN %s\n",channel);
	tcp.senddata (out, strlen (out));
	sprintf (out,":%s",nickname);
	
	while (step < 3) {
		inlen = tcp.getdata (inbuffer, TCP_INSIZE);
		inbuffer[inlen] = 0;
		if (inlen <0) return;

		/* wait untill we have joined the channel */
		if ((strstr (inbuffer, out) == inbuffer) && (strstr (inbuffer, "JOIN :") != NULL))
			step = 3;
	}
	
	cout << "IRCBot is now Online\n";
}

IRCClient::~IRCClient () {
};

void IRCClient::sendline (char *to, char *text) {
	char out[TCP_INSIZE];
	
	if (to == NULL) 
		sprintf (out, "PRIVMSG %s :%s", chan, text);
	else
		sprintf (out, "PRIVMSG %s :%s", to, text);
	tcp.senddata (out, strlen (out));
};

int IRCClient::loop () {
	char out[TCP_INSIZE];
	char in[TCP_INSIZE];
	char *p1;
	int inlen;

	inlen = tcp.getdata (in, TCP_INSIZE);
	if (inlen < 0)
		return -1;
	in[inlen] = 0;
	
	if (strstr(in,"PING") == in) {
		p1 = strchr (in,':');
		if (p1 == NULL) 
			fprintf (stderr,"Fehler PING ohne :\n");
		else {
			p1++;
			sprintf (out, "PONG %s\n",p1);
			tcp.senddata (out,strlen(out));
		}
		inlen = 0; 
	}
	else if (getmessage (in, chan))
		return inlen;
	else if (getmessage (in, nick)) {
		sprintf (out, "Sorry this is only a IRC/BomberClone Chat bot. If you need any help"
						"ask %s With the Email %s \n", botowner, botemail);
		sendline (sendnick, out);
		return 0;
	}
	return 0;
};


void IRCClient::close () {
};


int IRCClient::getmessage (char *in, char *channick) {
	char *p1;
	int i;
	char txt [512];
	
	sprintf (txt, "PRIVMSG %s :", channick);
	if (strstr (in, txt) != NULL) {
		p1 = strchr (in, ':') + 1;
		
		for (i = 0; (i < 62 && p1[i] != 0 && p1[i] != '!'); i++)
			sendnick[i] = p1[i];
		sendnick [i] = 0;
		
		p1 = strchr (strstr (in, txt), ':') + 1;
		for (i = 0; (i < IRC_LINESIZE && p1[i] != 0 && p1[i] != '\n'); i++)
			sendtext[i] = p1[i];
		sendtext [i-1] = 0;
		
		return 1;
	}
	
	return 0;
};

