#include "../config.h"
#include "bcmserv.h"
#include "cpplist.h"

char botnick[64] = "";
int botenable = 0;
char botowner[128] = "";
char botpass[64] = "";
char botemail[128] = "";
char botchan[128] = "";
char bothost[128] = "";
char botport[10] = "";

void
load_config ()
{
    char *hd;
    char filename[255];
    char line[255];

    /* get the homedir */ 
        if ((hd = getenv ("HOME")) == NULL) {
        sprintf (filename, "%s", CFG_FILENAME);
        printf ("Variable HOME could not be found\n");
    }
    else {
        strncpy (filename, hd, 253);
        filename[strlen (filename) + 1] = 0;
        if (filename[strlen (filename) - 1] != '/')
            filename[strlen (filename)] = '/';
        sprintf (filename, "%s%s", filename, CFG_FILENAME);
    }

    /* load the config */
    ifstream cfg (filename);

    botenable = 0;

    while (cfg.getline (line, 255)) { // Discards newline char
        char *value = strchr (line, '=');

        if (value != NULL) {
            if (strstr (line, "botport") == line)
                strncpy (botport, value + 1, 64);
            else if (strstr (line, "botnick") == line)
                strncpy (botnick, value + 1, 64);
            else if (strstr (line, "botemail") == line)
                strncpy (botemail, value + 1, 64);
            else if (strstr (line, "bothost") == line)
                strncpy (bothost, value + 1, 64);
            else if (strstr (line, "botowner") == line)
                strncpy (botowner, value + 1, 64);
            else if (strstr (line, "botpass") == line)
                strncpy (botpass, value + 1, 64);
            else if (strstr (line, "botchan") == line)
                strncpy (botchan, value + 1, 64);
            else if (strstr (line, "botenable") == line)
                botenable = atoi (value + 1);
        }
    }
}


int
main ()
{
    char in[BUF_SIZE];
    struct _sockaddr addr;
    int inlen = 0;
    UDPNetwork net (DEFAULT_UDPPORT); // open server
    IRCClient *irc = NULL;

    cout << "BomberClone Master Server " << VERSION << "\n";

    load_config ();

    if (botenable)
        irc = new IRCClient (bothost, botport, botnick, botpass, botchan); // the connection to the irc network

    GameList glist;
    BrowseList blist;
    char data[BUF_SIZE];
    int i,
      nr;
    char host[255];
    char port[12];

    while (1) {
        inlen = net.getdata ((char *) &in, BUF_SIZE, &addr);
        in[inlen] = 0;
        if (inlen > 0)
            switch (in[0]) {

                /* new server or update old entry */
            case ('A'):
                cout << "Add\n";
                i = glist.count;
                glist.Add (&addr, in + 1);
                glist.PrintList ();
                if (blist.count) {
                    port[0] = host[0] = 0;
                    dns_filladdr (host, 255, port, 12, PF_UNSPEC, &addr);
                    nr = glist.Search (host, port);
                    glist.CreatePacket (nr, data, BUF_SIZE);
                    for (nr = 0; nr < blist.count; nr++) {
                        struct browse_entry *ge = blist.Get (nr);
                        net.senddata (ge->host, ge->port, data, strlen (data));
                    }
                }

                if (botenable) {
                    if (glist.count != i) {
                        struct game_entry *ge = glist.Get (i);

                        sprintf (data, "New Game Added (Name: %s  Addr: %s:%s  Ver:%d.%d.%d)\n",
                                 ge->name, ge->host, ge->port, ge->version.major, ge->version.minor,
                                 ge->version.sub);

                        irc->sendline (NULL, data);
                    }
                }
                break;


                /* chat message */
            case ('C'):
                port[0] = host[0] = 0;
                dns_filladdr (host, 255, port, 12, PF_UNSPEC, &addr);

                sprintf (data, "ZBC:%s\n", in + 1);
                /*  if (botenable)    // disbales we had some problems with
                   irc.sendline (NULL, data + 1);  */

                for (nr = 0; nr < glist.count; nr++) {
                    struct game_entry *ge = glist.Get (nr);

                    if ((strstr (host, ge->host) == NULL) || (strstr (port, ge->port) == NULL))
                        net.senddata (ge->host, ge->port, data, strlen (data));
                }
                break;


                /* del server */
            case ('D'):
                if (botenable) { // send information into the irc
                    port[0] = host[0] = 0;
                    dns_filladdr (host, 255, port, 12, PF_UNSPEC, &addr);
                    int nr = glist.Search (host, port);

                    if (nr >= 0) {
                        struct game_entry *ge = glist.Get (nr);
                        sprintf (data, "Game (%15s V%d.%d.%d Players %d/%d) Deleted\n", ge->name,
                                 ge->version.major, ge->version.minor, ge->version.sub,
                                 ge->curplayers, ge->maxplayers);
                        irc->sendline (NULL, data);
                    }
                }
                /* delete now the entry */
                glist.Del (&addr);
                if (blist.count) {
                    sprintf (data, "Enewlist\n");
                    for (nr = 0; nr < blist.count; nr++) {
                        struct browse_entry *ge = blist.Get (nr);
                        if ((strstr (host, ge->host) == NULL) || (strstr (port, ge->port) == NULL))
                            net.senddata (ge->host, ge->port, data, strlen (data));
                    }
                    if (glist.count)
                        for (i = 0; i < glist.count; i++) {
                            glist.CreatePacket (i, data, BUF_SIZE);
                            for (nr = 0; nr < blist.count; nr++) {
                                struct browse_entry *ge = blist.Get (nr);
                                net.senddata (ge->host, ge->port, data, strlen (data));
                            }
                        }
                }
                cout << "Del\n";
                break;


                /* Add Browser to Browselist */
            case ('B'):
                cout << "BrowseAdd\n";
                blist.Add (&addr, in + 1);
                blist.PrintList ();
                if (glist.count) {
                    for (nr = 0; nr < glist.count; nr++) {
                        glist.CreatePacket (nr, data, BUF_SIZE);
                        net.senddata (&addr, data, strlen (data));
                    }
                }
                else {
                    sprintf (data, "Enoentry\n");
                    net.senddata (&addr, data, strlen (data));
                }
                break;


                /* Del Browser from Browselist */
            case ('E'):
                cout << "BrowseDel\n";
                blist.Del (&addr);
                break;


                /* send the list to the client */
            case ('G'):
                sscanf (in + 1, "%d", &nr); // get the entry number
                if (nr >= glist.count) {
                    sprintf (data, "Enoentry\n");
                    net.senddata (&addr, data, strlen (data));
                }
                else {
                    glist.CreatePacket (nr, data, BUF_SIZE);
                    net.senddata (&addr, data, strlen (data));
                }
                break;
            }

        inlen = glist.count;
        glist.CleanUp ();
        blist.CleanUp ();
        if (botenable) {
            for (; (inlen = irc->loop ());) {
                int nr,
                  i;
                in[inlen] = 0;
				
				if (strstr (irc->sendtext, "!help") == irc->sendtext) {
					irc->sendline (NULL, " - BomberClone Master Server (with IRC BOT) Version " VERSION " -\n");
					irc->sendline (NULL, " !games - list all known running games\n");
					irc->sendline (NULL, " !help  - this help page\n");
					irc->sendline (NULL, " !stat  - some other statistic\n");
				}
				
				
				if (strstr (irc->sendtext, "!stat") == irc->sendtext) {
					irc->sendline (NULL, "Statisitc for the Server\n");
					irc->sendline (NULL, "BomberCloneMServ - " VERSION "\n");
					sprintf (data, "Counted Games : %d (IPv4:%d | IPv6:%d)\n", glist.stat_countedgamesv4+glist.stat_countedgamesv6,glist.stat_countedgamesv4, glist.stat_countedgamesv6);
					irc->sendline (NULL, data);
					sprintf (data,"`%s` (%s:%s) had the most players with %d\n", glist.stat_maxplayername, glist.stat_maxplayerhost, glist.stat_maxplayerport,glist.stat_maxplayers);
					irc->sendline (NULL, data);
				}
				
				
                if (strstr (irc->sendtext, "!games")  == irc->sendtext) {
                    irc->sendline (NULL, "Games List\n");
                    for (nr = 0; nr < glist.count; nr++) {
                        struct game_entry *ge = glist.Get (nr);
                        char data[BUF_SIZE];
                        if (ge->ai_family == PF_INET)
                            i = 4;
                        else
                            i = 6;
                        sprintf (data, "%15s State:%d V:%d.%d.%d Players:%d/%d IPv%d Addr:%s:%s\n", ge->name,
                                 ge->state, ge->version.major, ge->version.minor, ge->version.sub,
                                 ge->curplayers, ge->maxplayers, i, ge->host, ge->port);
                        irc->sendline (NULL, data);
                    }
					irc->sendline (NULL, "End of Games List\n");
                }
                else {
                    /*              char data[BUF_SIZE];   // even disabled because some big problems
                       for (nr = 0; nr < glist.count; nr++) {
                       struct game_entry *ge = glist.Get (nr);

                       sprintf (data, "ZIRC:%s :%s", irc.sendnick, irc.sendtext);
                       net.senddata (ge->host, ge->port, data, strlen (data));
                       } */
                }
            }
        }
        usleep (10000);
    }
    return (0);
}
