/* network.cc 
 */

#include "bcmserv.h"

/* 	The whole UDP Part    */
UDPNetwork::UDPNetwork (char *port) {
	sock = udp_server (port, PF_INET6);
};

UDPNetwork::~UDPNetwork () {
	udp_close (sock);
};

void UDPNetwork::senddata (char *host, char *port, char *data, int len) {
	struct _sockaddr Addr;
	
	dns_filladdr (host, LEN_SERVERNAME, port, LEN_PORT, PF_UNSPEC, &Addr);
		
	udp_send (sock, data, len, &Addr, PF_UNSPEC);
};

void UDPNetwork::senddata (struct _sockaddr *Addr, char *data, int len) {
	udp_send (sock, data, len, Addr, PF_UNSPEC);
};

int UDPNetwork::getdata (char *buf, int buf_size, struct _sockaddr *Addr) {
	return udp_get (sock, buf, buf_size, Addr, PF_UNSPEC);
};


/* The TCP Part */
TCPClient::TCPClient () {
	sock = -1;
};

TCPClient::~TCPClient () {
	tcp_close (sock);
	sock = -1;
};

void TCPClient::connect (char *host, char *port) {
	if (sock != -1)
		tcp_close (sock);
	
	sock = tcp_connect (host, port);
};


int TCPClient::getdata (char *buf, int buf_size) {
	if (sock == -1)
		return -1;
	
	return tcp_get (sock, buf_size, buf);
};


void TCPClient::senddata (char *data, int len) {
	if (sock == -1)
		return;
	
	tcp_send (sock, data, len);
};


void TCPClient::close () {
	if (sock != -1)
		tcp_close (sock);
	
	sock = -1;
};

